﻿/*! 
 * Text Perspective Distortion Compensation v.0.0.6
 * Скрипт для оптимизации перспективных искажений текста
 * Описание: https://medium.com/p/ceee9caea7f/
 *
 * Автор: Сергей Николаев
 * kefiijrw.com
 *
 * Date: 2020-08-09
 *
 */

//хз зачем это, взрослые дяди так делают
// #targetengine "session";

//работаем с текущим документов
var doc = app.activeDocument;

//коэффициент для конвертации миллиметров в пункты и обратно
var mm = 2.834645;


// ПАРАМЕТРЫ ВЫПОЛНЕНИЯ СКРИПТА ПО УМОЛЧАНИЮ

//дистанция до носителя в сантиметрах
var distance = 250;

// коэффициент компенсации (растягивания по вертикали) от 0 до 1 
// 0 – без компенсации 
// 1 — чтобы верхняя строка оптически была точно как нижняя
var perspective_coeff = 0.5;

// коэффициент сохранения формы символов (растягивания по горизонтали) от 0 до 1
// 0 – буквы растягиваются только по вертикали 
// 1 — чтобы буквы растягивались по горизонтали настолько же, насколько и по вертикали
var scale_coeff = 0;

// коэффициент компенсации интерлиньяжа от 0 до 1
// 0 — интерлиньяж остается неизменным
// 1 — интерлиньяж увеличится настолько же, насколько и высота символов
var leading_coeff = 0;

// уровень глаз наблюдателя, определяем по линии в слое eyes level, перегоняем в см
var eyes_level;

//скрипт обрабатывает выделенный текст
var selected = true;

//показываем ли панель с настройками
var ui = true;

//пишем ли в лог-файл
var debug_mode = false;
var f_time = {};
var f_time_p = {};

//глобальная переменная (да, я знаю) для хранения текущего обрабатываемого текста
var current_txt;






// ВСПОМОГАТЕЛЬНЫЕ ФУНКЦИИ ДЛЯ ОТЛАДКИ

//пишем в файл лога (с кириллицей не работает) строку what
function echo(what) {
   if (debug_mode)
      log_file.write(what + '\n');
}



// структура объекта для вывода в отладке
function print_r(arr, level) {
   echo('print_r');
   var dumped_text = "";
   if (!level) level = 0;

   //The padding given at the beginning of the line.
   var level_padding = "";
   for (var j = 0; j < level + 1; j++) level_padding += "    ";

   if (typeof (arr) == 'object') { //Array/Hashes/Objects 
      for (var item in arr) {
         var value = arr[item];

         if (typeof (value) == 'object') { //If it is an array,
            dumped_text += level_padding + "'" + item + "' ...\n";
            dumped_text += print_r(value, level + 1);
         } else if(typeof (value) == 'number') {
            // dumped_text += level_padding + item+' '+typeof (value) + "\n";
            dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
         } else {
            // dumped_text += level_padding + item+' '+typeof (value) + "\n";
            // dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
         }
      }
   } else { //Stings/Chars/Numbers etc.
      dumped_text = "===>" + arr + "<===(" + typeof (arr) + ")";
   }
   return dumped_text;
}



// нарисовать линию на уровне y и подписать ее hint (для отладки нужно было)
function show_level(y, hint) {
   var tmp_layer = doc.layers.getByName('tmp');

   var line = tmp_layer.pathItems.add();
   line.stroked = true;

   line.setEntirePath(Array(Array(0, y), Array(100, y)));

   // тестовое описание
   // var text_hint = tmp_layer.textFrames.add();
   // text_hint.contents = hint;
   // text_hint.top = y;

}


// скопировать текущее состояние текстового поля txt на отладочный слой, чтобы можно было его изучить потом
// capt – строчка для добавления в название дубликата для идентификации
function snapshot(capt, in_file) {
   f_start(arguments.callee.name);

   txt = current_txt;


   if(txt.typename == 'TextFrame'){
      var snap = txt.duplicate(doc.layers.getByName('tmp'));
      snap.name = capt + '→' + distance + ';' + perspective_coeff + ';' + scale_coeff + ';' + leading_coeff;

/*
      // если еще сохранять их хочется в файлы
      var png_options = new ImageCaptureOptions();
      png_options.transparency = false;
      png_options.resolution = 75;
      png_options.antiAliasing = true;


      if(in_file){
         echo('png');
         var artRect = doc.artboards[0].artboardRect;  
         doc.imageCapture(File('~/Desktop/logs/'+capt+'.png'), artRect, png_options);

      }
      */

   }

   f_end(arguments.callee.name);
}


/* засекаем время начала выполнения функции, чтобы потом можно было оценить производительность и понять, на что тратится время*/
function f_start(f_name){
   f_time_p[f_name] = Date.now();
}


/* засекаем конце выполнения функции*/
function f_end(f_name){
   var time_b = Date.now();

   //считаем продолжительность выполнения
   var time_res = (time_b - f_time_p[f_name]);

   //сохраняем для дальнейшего изучения
   if( f_time[f_name] ){
      f_time[f_name] += time_res;
   } else{
      f_time[f_name] = time_res;
   }

}




// округление до сотых
function roundOff(x) {
   f_start(arguments.callee.name);
   var place = 100;
   x = Math.round(x * place);
   x /= place;
   f_end(arguments.callee.name);
   return x;
}


// Открыть ссылку. 
// взял отсюда: https://community.adobe.com/t5/indesign/js-scriptui-url-links-in-dialogues/td-p/4572773?page=1
function GotoLink(url) {

   url = url || "https://medium.com/p/ceee9caea7f/";

   if (!/^http/.test('' + url)) {
      url = 'https://' + url;
   }

   if (app.version > 6) {

      if (File.fs == "Macintosh") {

         var body = 'tell application "Finder"\ropen location "' + url + '"\rend tell';
         app.doScript(body, ScriptLanguage.APPLESCRIPT_LANGUAGE);

      } else {

         var body = 'dim objShell\rset objShell = CreateObject("Shell.Application")\rstr = "' + url + '"\robjShell.ShellExecute str, "", "", "open", 1 ';
         app.doScript(body, ScriptLanguage.VISUAL_BASIC);

      }

   }

   else {

      var linkBody = '<html><head><META HTTP-EQUIV=Refresh CONTENT="0; URL=' + url + '"></head><body> <p></body></html>';
      var linkJumper = File(Folder.temp.absoluteURI + "/link.html");
      linkJumper.open("w");
      linkJumper.write(linkBody);
      linkJumper.close();
      linkJumper.execute();

   }

}



// ОСНОВНЫЕ ФУНКЦИИ, ОТВЕЧАЮЩИЕ ЗА КОМПЕНСАЦИЮ ИСКАЖЕНИ


// корневая функция
function do_it() {
   f_start(arguments.callee.name);
   // что будем обрабатывать скриптом
   var wher;

   echo('=====================================');
   echo('do_it with settings ' + distance + '; ' + perspective_coeff + '; ' + scale_coeff + '; ' + leading_coeff);

   var sel = doc.selection;

   try{
      eyes_level = (-doc.layers.getByName('eyes_level').pathItems[0].top) / (10 * mm);
   } catch(err){
      alert(loc('Для запуска скрипта нужен слой eyes_level и линия в нем, по которой будет определяться уровень глаз относительно макета','You need the eyes_level layer and a line in it, which will determine the level of the eyes relative to the text'));
      exit();
   }


   //какие текстовые поля обрабатываем — выделенные...
   if (selected && sel.length > 0) {
      // TODO: проверять, есть ли в выделении текстовые поля?

      echo('with ' + sel.length + ' selected');
      wher = sel;

   } else {
      //или вообще все

      echo('for all ' + doc.textFrames.length + ' textFrames');
      wher = doc.textFrames;

   }

   f_end(arguments.callee.name);
   recursive_txt(wher);
}


/**
 * рекурсивный разбор содержимого where_is в поисках текстовых полей, 
 * которые можно скормить алгоритму компенсации
 */
function recursive_txt(where_is) {
   f_start(arguments.callee.name);
   echo('=recursive_txt');
   echo(where_is.length);

   //TODO: кажется, тут всё глупо сделано и я сам не до конца понимаю, как всё работает

   /**
    * where_is может быть группой или текстовым полем или просто набором разных выделенных объектов
    * для каждого возможного случая пробуем свои методы
    */

   try {
      // если это набор объектов
      for (var j = 0; j < where_is.length; j++) {
         echo(j + ' of ' + where_is.length + '; try 1');
         echo(where_is[j].typename);

         if (where_is[j].typename == 'TextFrame') {
            // текстовое поле — за дело!
            f_end(arguments.callee.name);
            calc_txt(where_is[j]);
            f_start(arguments.callee.name);

         } else if (where_is[j].typename == 'GroupItem') {
            // группа — спустимся на уровень ниже
            f_end(arguments.callee.name);
            recursive_txt(where_is[j]);
            f_start(arguments.callee.name);
         }

      }
   } catch (e) { }

   //если в where_is есть текстовые поля, запустить на них алгоритм
   try {
      for (var j = 0; j < where_is.textFrames.length; j++) {
         echo(j + ' try 2');
         f_end(arguments.callee.name);
         calc_txt(where_is.textFrames[j]);
         f_start(arguments.callee.name);
      }
   } catch (e) { }

   //если в where_is есть группы, пошерстить в них
   try {
      for (var j = 0; j < where_is.groupItems.length; j++) {
         echo(j + ' try 3');
         f_end(arguments.callee.name);
         recursive_txt(where_is.groupItems[j]);
         f_start(arguments.callee.name);
      }
   } catch (e) { }
   f_end(arguments.callee.name);
}


/**
 * Корневая функция обработки текстового поля txt
 * Делает несколько проверочек и запускает дело
 */
function calc_txt(txt) {
   f_start(arguments.callee.name);
   echo('==calc_txt');
   echo(' ');

   // если текстовое поле отображается...
   if (txt.hidden == false && txt.layer.visible == true) {

      // ...то за дело!
      try {
         current_txt = txt;
         f_end(arguments.callee.name);
         compensate_text(txt);
         f_start(arguments.callee.name);
      } catch (err) {
         echo('ERROR ' + err);
      }


   }
   f_end(arguments.callee.name);
}





/**
 * Скомпенсирует перспективные искажения текстового поля txt
 */
function compensate_text(txt) {
   f_start(arguments.callee.name);
   echo('===compensate_text');

   // тип текстового поля (Point Type, Area Type, Path Text).
   // скрипт работает с первыми двумя вариантами, текст вдоль кривой игнорирует
   var kind = txt.kind;

   /**
    * [y] хранит координату текущей строки, нужную для вычисления искажений.
    * Иллюстратор не умеет выдавать координаты строк, поэтому приходится самостоятельно 
    * ее считать, скускаясь построчно по текстовоговому полю и прибавляя интерлиньяж.
    * Для первой строки берем координату всего текстового поля...
    */
   var y = txt.top;

   /**
    * ...и чуть опускаемся, чтобы приземляемся где-то на уровень центра строчных букв.
    * Интерлиньяж первой строки ни на что не влияет, поэтому берем кегль.
    * Но вообще-то положение линии набора зависит от метрик шрифта, а доступа к ним нет,
    * поэтому это просто примерное прицеливание в буквы среднестатистического шрифта
    */
   y -= txt.lines[0].characterAttributes.size / 2;


   //show_level(y, kind + 'overal 2');

   if (kind == TextType.AREATEXT) {
      /**
       * Если это area type, то текст разбивается на абзацы, а внутри них — на строки
       */

      echo('AREA TYPE');

      // идем по списку абзацев
      for (var j = 0; j < txt.paragraphs.length; j++) {
         echo(' ');
         echo(' ');
         echo('paragraph ' + j);

         var par = txt.paragraphs[j];

         //если это не первый абзац, но учитываем его отступ до
         if (j != 0) {
            y -= par.paragraphAttributes.spaceBefore;
         }


         // идем по списку строчек абзаца
         for (var i = 0; i < par.lines.length; i++) {

            // snapshot(j + ':' + i);

            var line = par.lines[i];
            echo(' ');
            echo(' ');
            echo('   >line ' + i + ': ' + line.contents);
            echo('   >line len is ' + line.characters.length);
            

            //обрабатываем эту строку, в ответ получаем обновленную координату y с учетом искажений и изменившегося положения строки
            f_end(arguments.callee.name);
            y = compensate_line(par, i, i + j == 0, y);
            f_start(arguments.callee.name);

            echo('   >new line len is ' + par.lines[i].length);
            echo('   >new line is ' + par.lines[i].contents);

         }
         // show_level(y, ' after');
         // echo('end of paragraph' +y);

         //не забываем про отступ в конце
         y -= par.paragraphAttributes.spaceAfter;

      }

   } else if (kind == TextType.POINTTEXT) {
      /**
       * Если это point type, то всё очень тупо: вместо разбиения на абзацы текст разбивается только на строки,
       * но в конце одних строк (которые внутри абзаца) стоит принудительный перенос строки Force break, 
       * а в конце других (конечных строчек абзаца) уже обычный символ окончания строки (возврат каретки) \r. 
       * Из-за этого приходится изъебываться
       */

      echo('POINT TYPE');

      // Берем весь текст и разбиваем по символу возврата коретки, то есть делим на абзацы
      var cont_par = txt.contents.split('\r');

      // Текст абзацев разбиваем по символу Force break
      for (var i = 0; i < cont_par.length; i++) {
         cont_par[i] = cont_par[i].split('');
      }

      /**
       * Так получаем cont_par — двумерный массив с текстом строк внутри абзацев
       * Но взаимодействовать мы должны всё равно с реальными строками иллюстратора
       * Поэтому мы будем идти циклом по строка текстового поля, но параллельно смотреть, 
       * в каком месте двумерного массива строк мы находимся, и так отлавливать начала 
       * и окончания абзацев. Слава говнокоду!
       */

      //координаты в двумерном массиве cont_par текущей строки
      var j = 0, k = 0;

      // флаг «эта строчка была последняя в абзаце»
      var was_last = false;

      //идем по всем строка текстового поля
      for (var i = 0; i < txt.lines.length; i++) {

         var line = txt.lines[i];
         echo('>line ' + i);

         //если перед этим была последняя строка абзаца, то добавляем предабзацный отступ
         if (was_last == true) {
            y -= line.paragraphAttributes.spaceBefore;
            was_last = false;
         }

         //обрабатываем эту строку, в ответ получаем обновленную координату y с учетом искажений и изменившегося положения строки
         f_end(arguments.callee.name);
         y = compensate_line(txt, i, i == 0, y);
         f_start(arguments.callee.name);

         // show_level(y, kind + ' '+line.contents);

         //синхронизируем координаты строки в двумерном массиве
         if (line.contents == cont_par[j][k]) {

            //если это последняя строчка в параграфе,
            if (k == cont_par[j].length - 1) {

               // echo('LAST');
               //то добавляем послеабзацный доступ
               y -= line.paragraphAttributes.spaceAfter;
               j++;
               k = 0;
               was_last = true;

            } else {
               k++;
            }

         } else {
            echo('WTF:');
            echo(line.contents);
            echo(cont_par[j][k]);
         }

      }

   }
   f_end(arguments.callee.name);

}


/**
 * Функция компенсирует искажения для строки. Строка передается не прямо,
 * а как номер line_n в текстовом поле txt, чтобы иметь возможность связываться
 * с соседними строками
 * @param {textFrame} txt текстовое поле или абзац, к которому относится строка
 * @param {number} line_n номер строки в этом текстовом поле
 * @param {bool} is_first_line первая ли это строка в текстовом поле
 * @param {number} y координата [y] строки
 * возвращаем обновленную координату [y] после всех искажений
 */
function compensate_line(txt, line_n, is_first_line, y) {
   f_start(arguments.callee.name);
   echo('====compensate_line');

   var line = txt.lines[line_n];

   // считаем изначальный интерлиньяж у строки до нашего вмешательства
   f_end(arguments.callee.name);
   var original_leading = calc_leading(line);
   f_start(arguments.callee.name);
   // echo('   original leading is '+original_leading);

   // если это не первая строка первого абзаца,
   if (!is_first_line) {

      // то опускаем координату на интерлиньяж обсчитываемой строчки, чтобы она указывала на уровень символов
      y -= original_leading;
      // echo('   down step original leading = ' + original_leading);

   } else {
      // echo('   first line, ignoring original leading');
   }

   /**
    * Так как после высчитывания растяжения на уровне [y] строчка с компенсацией интерлиньяжа сместится по вертикали, 
    * то компенсация будет неактуальной (высчитывали для одной позиции, а строчка теперь стоит в другой), 
    * и для этого надо повторно просчитать для нового уровня строчки. А потом еще и еще... опытным путем определено, 
    * что за три итерации процесс сходится до погрешности 0.06% (по крайней мере на тестовых макетах).
    */


   //количество обсчетов
   var cicle_count = 1;

   /**
    * имеет смысл проделывать, только если компенсируется интерлиньяж, 
    * то есть строчка перемещается по вертикали от компенсаций искажений
    * ну и если это не первая строка текстового поля, так как у нее интерлиньяж
    * вообще ни на что не влияет
    * */
   if (leading_coeff > 0 && !is_first_line) {
      //TODO: вместо примерного числа итерация считать до достижения некоторой точности
      cicle_count = 2;
   }

   var previus_leading = original_leading;

   //подходы к обсчету строки
   for (var i = 0; i < cicle_count; i++) {

      // show_level(y, 'cicle ' + i + ': ' + line.contents);
      

      echo(' ');
      echo('      trying ' + (i+1) + ', calculate for y = ' + y);

      //применяем искажения, в ответ получаем новый интерлиньяж строки
      f_end(arguments.callee.name);
      var new_leading = calc_line(txt, line_n, y, original_leading, i);
      f_start(arguments.callee.name);

      // snapshot(i + ':' + y, true);

      //если это не первая строка первого абзаца
      if (!is_first_line) {

         echo('      new_leading = ' + new_leading);

         /**
          * Корректируем координату [y] по разнице между предыдущим и новым интерлиньяжами, 
          * чтобы она вновь попадала в сместившуюся строку
          * */
         y -= (new_leading - previus_leading);

      } else {

         echo('      ITS first line, ignore leading changes');

      }

      previus_leading = new_leading;
   }

   f_end(arguments.callee.name);
   return y;

}




/**
 * Вспомогательная функция определения интерлиньяжа у строки line.
 */
function calc_leading(line) {
   f_start(arguments.callee.name);

   /**
    * Так как реальный вертикальный отступ строки от предыдущий зависит от максимального из интерлиньяжей 
    * символов этой строки, то устраиваем обход строки. Еще надо помнить про возможное значение интерлиньяжа auto
    * */

   var max_leading = -1;
   var lead;

   // если у строки стоит автоматическое межстрочное расстояние 
   // TODO: а что если у разных символов этой строки стоит разное значение?
   if (line.characterAttributes.autoLeading == true) {
      // echo('autoLeading');

      //обходим все символы строки
      for (var i = 0; i < line.characters.length; i++) {

         //считаем через значение автолидинга, который в формате процента от кегля. пересчитываем в пункты
         lead = line.characters[i].characterAttributes.size * line.characters[i].paragraphAttributes.autoLeadingAmount / 100;

         //обновляем максимум
         if (lead > max_leading) {
            max_leading = lead;
         }

      }

   } else {
      //если интерлиньяж задан явно

      // echo('not autoLeading');

      for (var i = 0; i < line.characters.length; i++) {

         // тут всё попроще - берем из свойств
         lead = line.characters[i].characterAttributes.leading;

         if (lead > max_leading) {
            max_leading = lead;
         }

      }



   }

   // echo(max_leading);
   f_end(arguments.callee.name);
   return max_leading;
}



/**
 * Функция, где непосредственно применяются трансформации к строке
 * Строка тут тоже передается неявно, как и в функции-родителе compensate_line()
 * @param {*} txt текстовое поле или абзац, к которому относится строка
 * @param {*} line_n номер строки в txt, который мы сейчас считаем
 * @param {*} y координата [y] строки
 * @param {*} original_leading оригинальный интерлиньяж строки. Так как эта функция может применяться 
 * к строке несколько раз (см. compensate_line), то у строки может быть уже перебит интерлиньяж
 * на скомпенсированный, поэтому для расчетов заранее сохраняется и передается оригинальный интерлиньяж.
 * Возвращаем новый интерлиньяж этой строки.
 */
function calc_line(txt, line_n, y, original_leading, iteration) {
   f_start(arguments.callee.name);
   echo('=====calc_line');

   var line = txt.lines[line_n];

   /**
    * если это повторный проход строки, то интерлиньяж уже растянутый,
    * и если эти символы перенесутся на другую строку, то растянут её
    * поэтому сбрасываем интерлиньяж — ниже он всё равно выставится,
    * но только тем символам, что останутся на строке
    */   
    // ради скорости применяем, только если надо
   if(iteration != 0){
      line.characterAttributes.leading = original_leading;
   }


   /**
    * приводим координаты строки в см, чтобы в той же размерности,
    * что и дистанция distance и уровень глаз eyes_level, которые 
    * тоже будут участвовать в вычислении искажений
    */
   var y_in_sm = -y / (10 * mm);

   /**
    * Cчитаем коэффициент сжатия по расстоянию строки от уровня глаз
    * Коэффициент y_comp имеет значение от 1 (нет искажений) до бесконечности (суперискажения)
    */
   f_end(arguments.callee.name);
   var y_comp = compensation(Math.abs(y_in_sm - eyes_level));
   f_start(arguments.callee.name);

   /**
    * Пересчитываем коэффициент с учетом меры компенсации искажений
    * Множество значений такое же, от 1 (нет искажений) до бесконечности
    */
   var y_perspective_coeff = (y_comp - 1) * perspective_coeff + 1;
   var y_scale_coeff       = (y_comp - 1) * scale_coeff + 1;

   echo('y_in_sm: '+y_in_sm);
   echo('eyes_level: '+eyes_level);
   echo('d: '+Math.abs(y_in_sm - eyes_level));
   echo('coef: '+y_comp);
   echo('y_perspective_coeff: '+y_perspective_coeff);
   echo('y_scale_coeff: '+y_scale_coeff);

   f_end(arguments.callee.name);
   
   //горизонтальный масштаб символов строки
   line = set_hor_scale(line, y_perspective_coeff, y_scale_coeff, txt, line_n);
   
   //вертикальный масштаб
   set_vert_scale(line,y_perspective_coeff, y_scale_coeff);
   
   //интерлиньяж
   var upd_leading = set_leading(line, original_leading, leading_coeff);

   return upd_leading;


}

// Обсчет горизонтального масштаба символов строки
function set_hor_scale(line, y_perspective_coeff, scale_coeff, txt, line_n){
   
   /**
    * Есть горизонтальное растяжение символов, из-за чего текст в Area Type может не умещаться
    * и перепрыгивать со строки на строку, надо отлавливать всякие побочные эффекты
    */

   if (scale_coeff == 0){ //на нет и суда нет
      return line;
   }
   f_start(arguments.callee.name);



   // var hor_scale_compensated = 100 + (y_perspective_coeff * 100 - 100) * scale_coeff;
   var hor_scale_compensated = 100 * scale_coeff;

   // echo('>>>' + line.start + ' -> ' + line.end);

   
   echo('horizontalScale: ' + hor_scale_compensated);

   //если это Point text, то можно просто применять растягивание
   if(current_txt.kind == TextType.POINTTEXT){

      //применяем к символам соответсвующее их положению горизонтальное растяжение    
      line.characterAttributes.horizontalScale = hor_scale_compensated;
      
   } else if(current_txt.kind == TextType.AREATEXT){
      //если это Area Type, то тоже можно было бы сразу применить, но лучше сразу оптом

      // echo('>>>' + line.start + ' -> ' + line.end);

      /**
       * Теперь строчка может быть уже совсем не на своей строчке: какие-то символы могли перетечь на следующую строку,
       * какие-то наоборот, сузились и перепрыгнули на предыдущую строку, где они не умещались с предыдущим уровнем растяжения. 
       * Настало время охоты за беглецами
       */

      // текстовое поле или абзац, в котором всё происходит
      // TODO: надо ли тут заводить эту переменную или можно и оригинал портить
      var range = txt;
    

      /**
       * Во-первых, применяем горизонтальное растяжение нынешней строки ко всем символам ниже, чтобы если кто-то со следующей строки решит,
       * что он теперь может уместиться и на предыдущей строке, то сделал это сейчас. 
       */

      //ставим у этого текстового диапазона начало на начало нашей строки, предварительно сохранив оригинальное значение
      var w = range.start;
    
      range.start = line.start;
    

      range.characterAttributes.horizontalScale = hor_scale_compensated;
    
      //возвращаем границы текстового диапазона на место
      range.start = w;
    


      //смотрим, что теперь находится на этой строке после того, как все потенциально разбежались на строки до и после
      var line_updated = txt.lines[line_n];
    

      // echo('length before horizontalScale: ' + line.length);
      // echo('length after horizontalScale: ' + line_updated.length);

      // echo(line.contents + ' -> ' + line_updated.contents);

      /**
       * При этом по переменной line по-прежнему хранятся все символы оригинальной строки, 
       * даже если они после растяжения разбежались по соседним строкам. Поэтому можно сравнить
       * оригинальную строку с тем, что оказалось на ее месте после искажений
       */
      //где новая строка находится в старой
      var i1 = line.contents.indexOf(line_updated.contents);

      //где старая строка находится в новой
      var i2 = line_updated.contents.indexOf(line.contents);

      // echo(i1 + ' & ' + i2);

      if (i1 == 0 && i2 == 0) {
         //строки эквивалентны, есть строка полностью осталась на своем месте, можно ничего дополнительно не предпринимать
         // echo('equal');

      } else if (i1 == 0 && i2 == -1) {
         /**
          * Строка сократилась, например:
          * Lorem ipsum dolor sit amet, consectetuer adipiscing  -> Lorem
          * Значит, какие-то символы не уместились и перебежали на следующую строку
          * Переопределяем переменную line, чтобы остальные искажения строки достались
          * только тому, что действительно осталось на этой строке
          */
         // echo('SHORTER, CHANGE LINE');
         line = line_updated;
         // echo('new line is ' + line.contents);

      } else if ( i1 == -1 && i2 == 0 ) {
         /**
          * Строка удлинилась, например:
          * consec -> consectetuer 
          * Значит, какие-то символы со следующей строки раньше были еще шире, и теперь чуть ужались и вернулись на эту строку
          * То же самое, переопределяем переменную line
          */

         // echo('LONGER, CHANGE LINE');
         line = line_updated;
         // echo('new line is ' + line.contents);

      } else if ( i1 != 0 && i2 == -1 ) {
         /**
          * Начало строки переползло на предыдущую строку, например:
          * elit, sed diam  -> sed diam 
          * В конце тоже могут добавиться новые символе из-за освободившегося места.
          * Так как переползшие наверх символы там не в тему (они там влезли только потому, 
          * что у них коэффициент горизонтального растяжения рассчитан для строки ниже, а если 
          * его пересчитать для нового уровня, то они снова не будут влезать и вернутся обратно,
          * но, опять же, с чужим уровнем растяжения, и т.д. и т.д.), надо их возвращат вниз.
          * Для этого к этим сбежавшим и следующим за ним символам применяется стиль «не разрывать»,
          * тогда они не смогут влезть на верхней строки и вернутся на родину.
          */

         // echo('LETS TURN BACK TO THIS STRING');
         // echo(line.start + ' -> ' + line.end);
         // echo(line_updated.start + ' -> ' + line_updated.end);

         /**
          * Проходим с начала оригинальной строки и заканчиваем началом обновленной,
          * то есть это как раз те символы, которые перебежали на предыдущую строку
          */
         for (var i = line.start; i <= line_updated.start; i++) {
            // echo(i+': '+txt.characters[i].contents);
            //TODO: быстрее ли будет, если не по одному символу, а диапазон сразу?
            txt.characters[i].characterAttributes.noBreak = true;
         }

         // echo('CHANGE LINE');
         /** 
          * Так как мы вернули те символы обратно и теперь вообще не понимаем, что где
          * то вместо назначения line_updated заново берем строку и задаем ей растяжение
          * TODO: а почему в остальных местах так не сделать?
         */
         line = txt.lines[line_n];
         line.characterAttributes.horizontalScale = hor_scale_compensated;
         // echo('new line is ' + line.contents);

      } else {
         echo('WTF');
      }

   }

   f_end(arguments.callee.name);
   return line;
   
}



// Обсчет вертикального масштаба символов строки
function set_vert_scale(line, y_perspective_coeff, y_scale_coeff){
   f_start(arguments.callee.name);
      /** 
    * С вертикальным растяжением символов всё просто, так как оно ничего не двигает
    * */
    var vert_scale = y_perspective_coeff * y_scale_coeff * 100;
   
   /* время исполнение скрипта сильно зависит от количество применений свойств к тексту, так что для оптимизации приходится делать дополнительную проверку*/
   if( line.characterAttributes.verticalScale != vert_scale){
      line.characterAttributes.verticalScale = vert_scale;
   }
   
   //считаем, насколько по вертикали опустить текст, чтобы строка при увеличении вертикального масштаба росла не вверх, а в обе стороны и в целом оставалась на своем месте
   var shift_in_percents = (vert_scale - 100)/2;
   var shift_in_points = line.characterAttributes.size*shift_in_percents/100;
   line.characterAttributes.baselineShift = -shift_in_points/2;

   echo('verticalScale: ' + vert_scale);
   echo('shift_in_percents: ' + shift_in_percents);
   echo('shift_in_points: ' + shift_in_points);
   echo('baselineShift: ' + line.characterAttributes.baselineShift);

   f_end(arguments.callee.name);
}


// Обсчет интерлиньяжа
function set_leading(line, original_leading, leading_coeff){
   f_start(arguments.callee.name);

   if (leading_coeff > 0) {

      // echo('leading too!');
      // set_leading(line, original_leading, leading_coeff);

      //TODO: исправить это непотребство на что-то нормальное
      var l = line.characters.length - 1;
      var style2 = line.characters[l].characterAttributes;

      if (style2.autoLeading == true) {

         //TODO: а это вообще надо или достаточно назначить leading?
         line.autoLeading = false;

      }

      //считаем новый интерлиньяж
      line.characterAttributes.leading = original_leading * (100 + (line.characterAttributes.verticalScale - 100) * leading_coeff) / 100;
      echo('new leading '+line.characterAttributes.leading+' = or '+original_leading+' x '+line.characterAttributes.verticalScale +'/'+100);

      f_end(arguments.callee.name);
      return line.characterAttributes.leading;

   } else {
      //не изменился интерлиньяж
      f_end(arguments.callee.name);
      return original_leading;
   }   
}


/* Коэффициент сжатия по вертикали*/
function compensation(y_coord) {
   f_start(arguments.callee.name);
   /**
    * Считаем расстояние от глаз до строчки по теореме Пифагора и делим на дистанцию до плоскости, 
    * чтобы получить безразмерную величину от 1 (никаких искажений) до бесконечности (очень большие искажения)
    */
    echo('sqrt('+distance+'(distance)**2 + '+ y_coord+'(y_coord)**2)/'+distance+'(distance)');
   var coef_y = Math.sqrt(distance * distance + y_coord * y_coord) / distance;
   f_end(arguments.callee.name);
   return coef_y;
}








// ФУНКЦИИ ПРО UI ПАНЕЛЬ С НАСТРОЙКАМИ



//обработка нажатия кнопки OK
function actionOK() {
   f_start(arguments.callee.name);
   echo('actionOK');
   /**
    * Так как скрипт выполняется в режиме предпросмотра, 
    * то при нажатии на ОК уже всё сделано, просто закрываем панель
    */
   settings.close();
   f_end(arguments.callee.name);
}

//обработка нажатия кнопки Cancel
function actionCanceled() {
   f_start(arguments.callee.name);

   // откатываем изменения и закрываем панель
   echo('onClose');
   app.undo();
   app.redraw();
   settings.close();
   f_end(arguments.callee.name);

}

// обновление параметров в панели
function settings_updated() {
   f_start(arguments.callee.name);

   echo('settings_updated');

   //сохраняем новое значение переменных
   distance = settings.distPnl.titleEt.text;
   perspective_coeff = settings.perspPnl.slide.value;
   scale_coeff = settings.scalePnl.slide.value;
   leading_coeff = settings.leadPnl.slide.value;




   // и пересчитываем для них
   app.undo();
   do_it();
   app.redraw();
   f_end(arguments.callee.name);
}

// TODO: название переменных сделать как везде

// 1. Управление дистанцией
// Двигаем слайдер
function distSliderChanged() {
   settings.distPnl.titleEt.text = Math.round(settings.distPnl.slide.value);
}

// Изменили текстовое поле
function distTextChanged() {
   settings.distPnl.slide.value = settings.distPnl.titleEt.text;
   settings_updated();
}


// 2. Управление коэффициентом компенсации
// Двигаем слайдер
function perspSliderChanged() {
   settings.perspPnl.titleEt.text = roundOff(settings.perspPnl.slide.value);
}

// Изменили текстовое поле
function perspTextChanged() {
   settings.perspPnl.slide.value = settings.perspPnl.titleEt.text;
   settings_updated();
}

// 3. Управление коэффициентом горизонтального масштаба
// Двигаем
function scaleSliderChanged() {
   settings.scalePnl.titleEt.text = roundOff(settings.scalePnl.slide.value);
}

// Изменили текстовое поле
function scaleTextChanged() {
   settings.scalePnl.slide.value = settings.scalePnl.titleEt.text;
   settings_updated();
}


// 3. Управление коэффициентом компенсации интерлиньяжа
// Двигаем
function leadSliderChanged() {
   settings.leadPnl.titleEt.text = roundOff(settings.leadPnl.slide.value);
}

// Изменили текстовое поле
function leadTextChanged() {
   settings.leadPnl.slide.value = settings.leadPnl.titleEt.text;
   settings_updated();
}



/**
 * Выдай строчку на нужном языке в зависимости от локали иллюстратора
 */
function loc(ru, en) {
   if (app.locale == 'ru_RU')
      return ru;
   else
      return en;
}


// Создаем панель с настройками
function build_ui(){
   f_start(arguments.callee.name);

   //болванку задаем
   var dlg = new Window('dialog', loc('Компенсация искажения текста', 'Text distortion compensation'));

   var s_w = 200;
   var ti_w = 40;
   var d_w = 29;
   var w = s_w + ti_w + 84;

   //устанавливаем свойства
   dlg.location = [1000, 500];
   dlg.alignChildren = ["left", "top"];
   dlg.preferredSize.width = w;
   dlg.margins = 15;

   //и начинаем ее заполнять

   // distance Дистанция (см) слайдер + инпут.     
   dlg.distPnl = dlg.add('panel', undefined, loc('Дистанция', 'Distance'));
   dlg.distPnl.orientation = 'row';
   dlg.distPnl.preferredSize.width = w - d_w;
   // dlg.distPnl.spacing = 0; 
   dlg.distPnl.margins = 10;

   dlg.distPnl.slide = dlg.distPnl.add('slider', undefined, distance, 50, 500);   //слайдер
   dlg.distPnl.slide.preferredSize.width = s_w;

   dlg.distPnl.sm_g = dlg.distPnl.add('group', undefined, 'so');   //слайдер
   dlg.distPnl.sm_g.spacing = 4;

   dlg.distPnl.titleEt = dlg.distPnl.sm_g.add('edittext', undefined, distance); //ипнут
   dlg.distPnl.titleEt.preferredSize.width = ti_w;

   dlg.distPnl.titleSt = dlg.distPnl.sm_g.add('statictext', undefined, loc("см", 'sm')); //размерность
   // dlg.distPnl.titleEt.preferredSize.width = 20; 
   dlg.distPnl.titleSt.helpTip = loc("сантиметров", "santimeters");


   // perspective_coeff Компенсация сжатия, от 0 до 1, слайдер + инпут
   dlg.perspPnl = dlg.add('panel', undefined, loc("Коэффициент компенсации перспективы", 'Perspective compensation coefficient'));
   dlg.perspPnl.orientation = 'row';
   dlg.perspPnl.preferredSize.width = w - d_w;
   dlg.perspPnl.margins = 10;

   dlg.perspPnl.slide = dlg.perspPnl.add('slider', undefined, perspective_coeff, 0, 1);//слайдер
   dlg.perspPnl.slide.preferredSize.width = s_w;
   dlg.perspPnl.titleEt = dlg.perspPnl.add('edittext', undefined, perspective_coeff);//инпут
   dlg.perspPnl.titleEt.preferredSize.width = ti_w;

   // scale_coeff Компенсация уменьшения, от 0 до 1, слайдер + инпут
   dlg.scalePnl = dlg.add('panel', undefined, loc("Коэффициент компенсации размера", 'Scale compensation coefficient'));
   dlg.scalePnl.orientation = 'row';
   dlg.scalePnl.preferredSize.width = w - d_w;
   dlg.scalePnl.margins = 10;

   dlg.scalePnl.slide = dlg.scalePnl.add('slider', undefined, scale_coeff, 0, 1);
   dlg.scalePnl.slide.preferredSize.width = s_w;
   dlg.scalePnl.titleEt = dlg.scalePnl.add('edittext', undefined, scale_coeff);
   dlg.scalePnl.titleEt.preferredSize.width = ti_w;

   // leading_coeff Компенсация интерлиньяжа, от 0 до 1, слайдер + инпут
   dlg.leadPnl = dlg.add('panel', undefined, loc("Коэффициент сохранения интерлиньяжа", 'Leading compensation coefficient'));
   dlg.leadPnl.orientation = 'row';
   dlg.leadPnl.preferredSize.width = w - d_w;
   dlg.leadPnl.margins = 10;

   dlg.leadPnl.slide = dlg.leadPnl.add('slider', undefined, leading_coeff, 0, 1);
   dlg.leadPnl.slide.preferredSize.width = s_w;
   dlg.leadPnl.titleEt = dlg.leadPnl.add('edittext', undefined, leading_coeff);
   dlg.leadPnl.titleEt.preferredSize.width = ti_w;

   // selected только выденное или всё. selected
   dlg.btnPnl = dlg.add('group', undefined, 'Do It!');
   dlg.btnPnl.orientation = 'row';
   dlg.btnPnl.alignment = "right";
   dlg.btnPnl.alignChildren = ["left", "center"];

   dlg.btnPnl_l = dlg.btnPnl.add('group', undefined, 'LEFT');
   dlg.btnPnl_l.orientation = 'row';
   dlg.btnPnl_l.alignment = "left";
   dlg.btnPnl_l.alignChildren = ["left", "center"];
   dlg.btnPnl_l.preferredSize.width = 110;//(w-d_w-10)/4;


   dlg.btnPnl_r = dlg.btnPnl.add('group', undefined, 'RIGHT');
   dlg.btnPnl_r.orientation = 'row';
   dlg.btnPnl_r.alignment = "right";
   // dlg.btnPnl_r.preferredSize.width = (w-d_w-10)*3/4;



   dlg.btnPnl.buildBtn0 = dlg.btnPnl_l.add('button', undefined, loc('Помощь', 'Help'), { name: 'help' });
   dlg.btnPnl.buildBtn0.alignment = ["left", "top"];

   dlg.btnPnl.buildBtn1 = dlg.btnPnl_r.add('button', undefined, loc('Отмена', 'Cancel'), { name: 'cancel' });
   dlg.btnPnl.buildBtn2 = dlg.btnPnl_r.add('button', undefined, 'OK', { name: 'ok' });

   dlg.btnPnl.buildBtn0.onClick = GotoLink;
   dlg.btnPnl.buildBtn1.onClick = actionCanceled;
   dlg.btnPnl.buildBtn2.onClick = actionOK;


   dlg.distPnl.slide.onChanging = distSliderChanged;
   dlg.distPnl.slide.onChange = settings_updated;
   dlg.distPnl.titleEt.onChanging = distTextChanged;

   dlg.perspPnl.slide.onChanging = perspSliderChanged;
   dlg.perspPnl.slide.onChange = settings_updated;
   dlg.perspPnl.titleEt.onChanging = perspTextChanged;

   dlg.scalePnl.slide.onChanging = scaleSliderChanged;
   dlg.scalePnl.slide.onChange = settings_updated;
   dlg.scalePnl.titleEt.onChanging = scaleTextChanged;

   dlg.leadPnl.slide.onChanging = leadSliderChanged;
   dlg.leadPnl.slide.onChange = settings_updated;
   dlg.leadPnl.titleEt.onChanging = leadTextChanged;


/*
   dlg.distPnl.titleEt.addEventListener("keydown", function(k) {
       handle_key(k, this);
   });




   dlg.distPnl.titleEt.addEventListener("blur", function(k) {
       // handle_key(k, this);
       // alert('so');
       settings_updated();
   });

*/

/*   // handle_key    
   e1.addEventListener("keydown", function(k) {
       handle_key(k, this);
   });

   e2.addEventListener("keydown", function(k) {
       handle_key(k, this);
   });
*/


   f_end(arguments.callee.name);
   return dlg;
}

/*
function handle_key(key, control) {
    var step;
    key.shiftKey ? step = 5 : step = 0.5;

    if( Number(control.text) - step < distance_min) return;
    if( Number(control.text) + step > distance_max) return;
    
    switch (key.keyName) {
        case "Up":
            control.text = String(Number(control.text) + step);
            break;
        case "Down":
            control.text = String(Number(control.text) - step);
    }

    // settings_updated();


}
*/


// ЗА ДЕЛО!!!

// Создаем лог-файл
if (debug_mode) {
   var logFile = "~/Desktop/logs/perspective_log.txt";
   var log_file = new File(logFile);
   log_file.open("w");
   log_file.charset = "UTF-8";
}

var time_a = Date.now();
var settings = build_ui();


echo('start!');
echo(app.locale);


//запускаем со стандартными параметрами
do_it();
app.redraw();

// показываем панель с настройками
if (ui)
   settings.show();

//какая функция сколько времения исполнялась
// echo(print_r(f_time));

var time_b = Date.now();
var time_res = (time_b - time_a)/1000; 
echo('total timing: '+time_res);
// alert( "Скрипт выполнялся за "+ time_res +" с." );

if (debug_mode) {
   log_file.close();
}